
Property changes on: .
___________________________________________________________________
Modified: svn:mergeinfo
   Merged /vendor/openbsm/dist:r195740-196028

Index: configure
===================================================================
--- configure	(revision 196028)
+++ configure	(working copy)
@@ -1,7 +1,7 @@
 #! /bin/sh
-# From configure.ac P4: //depot/projects/trustedbsd/openbsm/configure.ac#52 .
+# From configure.ac P4: //depot/projects/trustedbsd/openbsm/configure.ac#53 .
 # Guess values for system-dependent variables and create Makefiles.
-# Generated by GNU Autoconf 2.62 for OpenBSM 1.1p1.
+# Generated by GNU Autoconf 2.62 for OpenBSM 1.1p2.
 #
 # Report bugs to <trustedbsd-audit@TrustesdBSD.org>.
 #
@@ -751,8 +751,8 @@
 # Identity of this package.
 PACKAGE_NAME='OpenBSM'
 PACKAGE_TARNAME='openbsm'
-PACKAGE_VERSION='1.1p1'
-PACKAGE_STRING='OpenBSM 1.1p1'
+PACKAGE_VERSION='1.1p2'
+PACKAGE_STRING='OpenBSM 1.1p2'
 PACKAGE_BUGREPORT='trustedbsd-audit@TrustesdBSD.org'
 
 ac_unique_file="bin/auditreduce/auditreduce.c"
@@ -1492,7 +1492,7 @@
   # Omit some internal or obsolete options to make the list less imposing.
   # This message is too long to be a string in the A/UX 3.1 sh.
   cat <<_ACEOF
-\`configure' configures OpenBSM 1.1p1 to adapt to many kinds of systems.
+\`configure' configures OpenBSM 1.1p2 to adapt to many kinds of systems.
 
 Usage: $0 [OPTION]... [VAR=VALUE]...
 
@@ -1562,7 +1562,7 @@
 
 if test -n "$ac_init_help"; then
   case $ac_init_help in
-     short | recursive ) echo "Configuration of OpenBSM 1.1p1:";;
+     short | recursive ) echo "Configuration of OpenBSM 1.1p2:";;
    esac
   cat <<\_ACEOF
 
@@ -1671,7 +1671,7 @@
 test -n "$ac_init_help" && exit $ac_status
 if $ac_init_version; then
   cat <<\_ACEOF
-OpenBSM configure 1.1p1
+OpenBSM configure 1.1p2
 generated by GNU Autoconf 2.62
 
 Copyright (C) 1992, 1993, 1994, 1995, 1996, 1998, 1999, 2000, 2001,
@@ -1685,7 +1685,7 @@
 This file contains any messages produced by compilers while
 running configure, to aid debugging if configure makes a mistake.
 
-It was created by OpenBSM $as_me 1.1p1, which was
+It was created by OpenBSM $as_me 1.1p2, which was
 generated by GNU Autoconf 2.62.  Invocation command line was
 
   $ $0 $@
@@ -19662,7 +19662,7 @@
 
 # Define the identity of the package.
  PACKAGE=OpenBSM
- VERSION=1.1p1
+ VERSION=1.1p2
 
 
 cat >>confdefs.h <<_ACEOF
@@ -24400,7 +24400,7 @@
 # report actual input values of CONFIG_FILES etc. instead of their
 # values after options handling.
 ac_log="
-This file was extended by OpenBSM $as_me 1.1p1, which was
+This file was extended by OpenBSM $as_me 1.1p2, which was
 generated by GNU Autoconf 2.62.  Invocation command line was
 
   CONFIG_FILES    = $CONFIG_FILES
@@ -24453,7 +24453,7 @@
 _ACEOF
 cat >>$CONFIG_STATUS <<_ACEOF || ac_write_fail=1
 ac_cs_version="\\
-OpenBSM config.status 1.1p1
+OpenBSM config.status 1.1p2
 configured by $0, generated by GNU Autoconf 2.62,
   with options \\"`$as_echo "$ac_configure_args" | sed 's/^ //; s/[\\""\`\$]/\\\\&/g'`\\"
 
Index: VERSION
===================================================================
--- VERSION	(revision 196028)
+++ VERSION	(working copy)
@@ -1 +1 @@
-OPENBSM_1_1p1
+OPENBSM_1_1p2
Index: README
===================================================================
--- README	(revision 196028)
+++ README	(working copy)
@@ -1,4 +1,4 @@
-OpenBSM 1.1
+OpenBSM 1.1p2
 
   Introduction
 
@@ -64,4 +64,4 @@
 
     http://www.TrustedBSD.org/
 
-$P4: //depot/projects/trustedbsd/openbsm/README#36 $
+$P4: //depot/projects/trustedbsd/openbsm/README#37 $
Index: tools/audump.c
===================================================================
--- tools/audump.c	(revision 196028)
+++ tools/audump.c	(working copy)
@@ -1,5 +1,5 @@
 /*-
- * Copyright (c) 2005-2006 Robert N. M. Watson
+ * Copyright (c) 2005-2009 Robert N. M. Watson
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -23,7 +23,7 @@
  * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
  * SUCH DAMAGE.
  *
- * $P4: //depot/projects/trustedbsd/openbsm/tools/audump.c#8 $
+ * $P4: //depot/projects/trustedbsd/openbsm/tools/audump.c#9 $
  */
 
 #include <bsm/libbsm.h>
@@ -165,16 +165,16 @@
 
 	first = 1;
 	for (i = 0; i < 32; i++) {
-		if (classmask & (2 << i)) {
+		if (classmask & (1 << i)) {
 			if (first)
 				first = 0;
 			else
 				printf(",");
-			c = getauclassnum(2 << i);
+			c = getauclassnum(1 << i);
 			if (c != NULL)
 				printf("%s", c->ac_name);
 			else
-				printf("0x%x", 2 << i);
+				printf("0x%x", 1 << i);
 		}
 	}
 }
Index: configure.ac
===================================================================
--- configure.ac	(revision 196028)
+++ configure.ac	(working copy)
@@ -2,8 +2,8 @@
 # Process this file with autoconf to produce a configure script.
 
 AC_PREREQ(2.59)
-AC_INIT([OpenBSM], [1.1p1], [trustedbsd-audit@TrustesdBSD.org],[openbsm])
-AC_REVISION([$P4: //depot/projects/trustedbsd/openbsm/configure.ac#53 $])
+AC_INIT([OpenBSM], [1.1p2], [trustedbsd-audit@TrustesdBSD.org],[openbsm])
+AC_REVISION([$P4: //depot/projects/trustedbsd/openbsm/configure.ac#54 $])
 AC_CONFIG_SRCDIR([bin/auditreduce/auditreduce.c])
 AC_CONFIG_AUX_DIR(config)
 AC_CONFIG_HEADER([config/config.h])
Index: config/config.h
===================================================================
--- config/config.h	(revision 196028)
+++ config/config.h	(working copy)
@@ -164,13 +164,13 @@
 #define PACKAGE_NAME "OpenBSM"
 
 /* Define to the full name and version of this package. */
-#define PACKAGE_STRING "OpenBSM 1.1p1"
+#define PACKAGE_STRING "OpenBSM 1.1p2"
 
 /* Define to the one symbol short name of this package. */
 #define PACKAGE_TARNAME "openbsm"
 
 /* Define to the version of this package. */
-#define PACKAGE_VERSION "1.1p1"
+#define PACKAGE_VERSION "1.1p2"
 
 /* Define as the return type of signal handlers (`int' or `void'). */
 #define RETSIGTYPE void
@@ -191,7 +191,7 @@
 #define USE_NATIVE_INCLUDES /**/
 
 /* Version number of package */
-#define VERSION "1.1p1"
+#define VERSION "1.1p2"
 
 /* Use extended API on platforms that require it */
 #define _GNU_SOURCE /**/
Index: etc/audit_event
===================================================================
--- etc/audit_event	(revision 196028)
+++ etc/audit_event	(working copy)
@@ -1,5 +1,5 @@
 #
-# $P4: //depot/projects/trustedbsd/openbsm/etc/audit_event#40 $
+# $P4: //depot/projects/trustedbsd/openbsm/etc/audit_event#41 $
 # $FreeBSD$
 #
 # The mapping between event identifiers and values is also hard-coded in
@@ -272,7 +272,8 @@
 277:AUE_OPENAT_WTC:openat(2) - write,creat,trunc:fc,fd,fw,fa,fm
 278:AUE_OPENAT_RW:openat(2) - read,write:fr,fw
 279:AUE_OPENAT_RWC:openat(2) - read,write,create:fc,fw,fr,fa,fm
-280:AUE_OPENAT_RWTC:openat(2) - read,write,creat,trunc:fc,fd,fw,fr,fa,fm
+280:AUE_OPENAT_RWT:openat(2) - read,write,trunc:fd,fw,fr,fa,fm
+281:AUE_OPENAT_RWTC:openat(2) - read,write,creat,trunc:fc,fd,fw,fr,fa,fm
 282:AUE_RENAMEAT:renameat(2):fc,fd
 283:AUE_FSTATAT:fstatat(2):fa
 284:AUE_FCHOWNAT:fchownat(2):fm
Index: NEWS
===================================================================
--- NEWS	(revision 196028)
+++ NEWS	(working copy)
@@ -1,5 +1,11 @@
 OpenBSM Version History
 
+OpenBSM 1.1p2
+
+- Fix audit_event definitions of AUE_OPENAT_RWT and AUE_OPENAT_RWTC.
+- Fix build on Linux.
+- Fix printing of class masks in the audump tool.
+
 OpenBSM 1.1p1
 
 - Fixes to AUT_SOCKUNIX token parsing.
@@ -458,4 +464,4 @@
   to support reloading of kernel event table.
 - Allow comments in /etc/security configuration files.
 
-$P4: //depot/projects/trustedbsd/openbsm/NEWS#42 $
+$P4: //depot/projects/trustedbsd/openbsm/NEWS#43 $